unit CdfPrg;                    // 417

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TCdfFPrg = class(TForm)
    solution1: TLabel;
    TrackBar1: TTrackBar;
    Panel1: TPanel;
    Button1: TButton;
    Effectif: TLabeledEdit;
    UpFinale: TUpDown;
    Label18: TLabel;
    E1: TLabeledEdit;
    UpE1: TUpDown;
    Label19: TLabel;
    Panel2: TPanel;
    Label8: TLabel;
    T1: TLabeledEdit;
    Label1: TLabel;
    RG1: TRadioGroup;
    E2: TLabeledEdit;
    T2: TLabeledEdit;
    Label2: TLabel;
    Label10: TLabel;
    RG2: TRadioGroup;
    Label9: TLabel;
    E3: TLabeledEdit;
    Label16: TLabel;
    T3: TLabeledEdit;
    Label3: TLabel;
    Label11: TLabel;
    RG3: TRadioGroup;
    E4: TLabeledEdit;
    Label17: TLabel;
    T4: TLabeledEdit;
    Label4: TLabel;
    RG4: TRadioGroup;
    Label12: TLabel;
    T5: TLabeledEdit;
    Label5: TLabel;
    Label13: TLabel;
    RG5: TRadioGroup;
    T6: TLabeledEdit;
    Label6: TLabel;
    RG6: TRadioGroup;
    T7: TLabeledEdit;
    Label7: TLabel;
    Label15: TLabel;
    Label14: TLabel;
    Button2: TButton;
    Button3: TButton;
    Solution2: TLabel;
    TrackBar2: TTrackBar;
    Finale: TEdit;
    Label21: TLabel;
    Solution3: TLabel;
    TrackBar3: TTrackBar;
    Fini: TLabel;
    ExempLabel: TLabel;
    ExempNbrs: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure UpFinaleClick(Sender: TObject; Button: TUDBtnType);
    procedure UpE1Click(Sender: TObject; Button: TUDBtnType);
    procedure EffectifExit(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  CdfFPrg: TCdfFPrg;

  
implementation

{$R *.dfm}

USES
  CdfDec, aprop;

procedure vidage(num : Byte);
VAR
  pt : Tdonnees;
begin
  CASE num OF
    1: BEGIN
      WHILE Donnees1.Ptsuivant<> NIL DO
        Donnees1 := Donnees1.Ptsuivant;
      WHILE Donnees1.Ptprecedant<> NIL DO
      BEGIN
        pt := Donnees1;
        Donnees1 := Donnees1.Ptprecedant;
        Dispose(pt);
      END;
      Dispose(Donnees1);
    END;
    2: BEGIN
      WHILE Donnees2.Ptsuivant<> NIL DO
        Donnees2 := Donnees2.Ptsuivant;
      WHILE Donnees2.Ptprecedant<> NIL DO
      BEGIN
        pt := Donnees2;
        Donnees2 := Donnees2.Ptprecedant;
        Dispose(pt);
      END;
      Dispose(Donnees2);
    END;
    3: BEGIN
      WHILE Donnees3.Ptsuivant<> NIL DO
        Donnees3 := Donnees3.Ptsuivant;
      WHILE Donnees3.Ptprecedant<> NIL DO
      BEGIN
        pt := Donnees3;
        Donnees3 := Donnees3.Ptprecedant;
        Dispose(pt);
      END;
      Dispose(Donnees3);
    END;
  END;
end;

procedure TCdfFPrg.Button1Click(Sender: TObject);
VAR
  bT1,bE2,bE3,bE4,bT2,bT3,bT4 : Integer;
  Eff                         : Integer;
  r1,r2                       : Real;
  pt                          : TDonnees;
  sol                         : Integer;
begin
  fini.Visible := FALSE;
  T2.Text := '';  T3.Text := '';
  E2.Text := '';  E3.Text := '';  E4.Text := '';
  Eff := StrToInt(Effectif.Text);
  For sol:=3 DownTO 1 DO
  BEGIN
    TTrackBar(FindComponent('TrackBar'+IntToStr(sol))).Visible := FALSE;
    Application.ProcessMessages;
    IF solut[sol]>0
    THEN vidage(sol);
    solut[sol] := 0;
    bt4 := StrToInt(Finale.Text);  T7.Text := IntToStr(bt4);
    bT1 := StrToInt(E1.Text);
    IF RG6.ItemIndex=0
    THEN bt4 := bt4 * 2
    ELSE bt4 := (bt4 * 4) DIV 3;
    T6.Text :=  IntToStr(bt4);
    IF RG5.ItemIndex=0
    THEN bt4 := bt4 * 2
    ELSE bt4 := (bt4 * 4) DIV 3;
    T5.Text :=  IntToStr(bt4);
    bT4 := bT4 + ( 1 - sol );
    IF RG4.ItemIndex=0
    THEN bt4 := (bt4 * 2)+ ( sol -1 )
    ELSE BEGIN
      bt4 := (bt4 * 4);
      IF (bt4 MOD 3)=0
      THEN bt4 := (bt4 DIV 3) - ( 1 - sol )
      ELSE bt4 := 0;
    END;
    FOR bE2:= 0 TO (Eff-bT1) DO
    BEGIN
      bT2 := ((bT1*3)DIV 4)+ bE2;
      IF ((bT2 MOD 4) = 0)
      THEN FOR bE3:=0 TO (Eff-bT1-bE2) DO
        BEGIN
          bT3 := ((bT2*3) DIV 4) + bE3;
          IF ((bT3 MOD 4) = 0)
          THEN FOR bE4:=0 TO (Eff-bT1-bE2-bE3) DO
              IF (bT1+bE2+bE3+bE4=Eff)
              THEN BEGIN
                r1 := (9*bT1/16) + (3*bE2/4) + bE3;
                r2 := bT3;
                IF r1 = r2
                THEN BEGIN
                  r1 := (27*bT1/64) + (9*bE2/16) + (3*bE3/4) + bE4 ;
                  r2 := bT4;
                  IF r1=r2
                  THEN BEGIN
                    Inc(solut[sol]);
                    IF solut[sol]=1
                    THEN BEGIN
                      pt := NIL;        ExempNbrs.Caption := IntToStr(sol-1);
                      ExempNbrs.Visible := TRUE;
                      ExempLabel.Visible := True;
                      CASE sol OF
                        3:BEGIN
                          ExempNbrs.Font.Color := clBlack;
                          ExempLabel.Caption := 'Exemptes';
                          ExempLabel.Font.Color := clBlack;
                        END;
                        2:BEGIN
                          ExempNbrs.Font.Color := clBlue;
                          ExempLabel.Caption := 'Exempte';
                          ExempLabel.Font.Color := clBlue;
                        END;
                        1:BEGIN
                          ExempNbrs.Visible := FALSE;
                          ExempLabel.Visible := FALSE;
                        END;
                      END;
                    END
                    ELSE CASE sol OF
                      3:pt := Donnees3;
                      2:pt := Donnees2;
                      1:pt := Donnees1;
                    END;
                  CASE sol OF
                    3:BEGIN
                      new(Donnees3);
                      Donnees3.Ptprecedant := pt;Donnees3.Ptsuivant := NIL;
                    END;
                    2:BEGIN
                      new(Donnees2);
                      Donnees2.Ptprecedant := pt;Donnees2.Ptsuivant := NIL;
                    END;
                    1:BEGIN
                      new(Donnees1);
                      Donnees1.Ptprecedant := pt;Donnees1.Ptsuivant := NIL;
                    END;
                  END;
                  IF solut[sol]>1
                  THEN CASE sol OF
                      3:pt.Ptsuivant := Donnees3;
                      2:pt.Ptsuivant := Donnees2;
                      1:pt.Ptsuivant := Donnees1;
                    END;
                  CASE sol OF
                    3:WITH Donnees3^ DO
                    BEGIN
                      T1 := bT1;T2 := bT2;T3 := bT3;
                      E2 := bE2;E3 := bE3;E4 := bE4;
                    END;
                    2:WITH Donnees2^ DO
                    BEGIN
                      T1 := bT1;T2 := bT2;T3 := bT3;
                      E2 := bE2;E3 := bE3;E4 := bE4;
                    END;
                    1:WITH Donnees1^ DO
                    BEGIN
                      T1 := bT1;  T2 := bT2;  T3 := bT3;
                      E2 := bE2;  E3 := bE3;  E4 := bE4;
                    END;
                  END;
                  T1.Text := IntToStr(bT1);  T2.Text := IntToStr(bT2);
                  T3.Text := IntToStr(bT3);  T4.Text := IntToStr(bt4);
                  E2.Text := IntToStr(bE2);  E3.Text := IntToStr(bE3);
                  E4.Text := IntToStr(bE4);
                END;
              END;
            END;
      END;
    END;
    TTrackBar(FindComponent('TrackBar'+IntToStr(sol))).Min := 1;
    TTrackBar(FindComponent('TrackBar'+IntToStr(sol))).Max := solut[sol];
    TTrackBar(FindComponent('TrackBar'+IntToStr(sol))).Position := 1;
    IF solut[sol]>0
    THEN BEGIN
      TTrackBar(FindComponent('TrackBar'+IntToStr(sol))).Visible := TRUE;
      TLabel(FindComponent('solution'+IntToStr(sol))).
              Caption :=  'Solution : '+IntToStr(1)
                                       +'/'+IntToStr(solut[sol]);
    END
    ELSE
    TLabel(FindComponent('solution'+IntToStr(sol))).Caption := '0 solution';
  END;
  IF (solut[1]=0) AND (solut[2]=0) AND (solut[3]=0)
  THEN fini.Visible := TRUE;
end;

procedure TCdfFPrg.FormActivate(Sender: TObject);
begin
  Effectif.Text := '71';
  Finale.Text := '6';  UpFinale.Position := 6;
  E1.Text := '20';
  UpE1.Position := 20; UpE1.Min := 0;
  UpE1.Max := (71 DIV 4)*4;
  Rg1.ItemIndex := 1;  RG2.ItemIndex := 1;  RG3.ItemIndex := 1;
  RG4.ItemIndex := 0;  RG5.ItemIndex := 0;  RG6.ItemIndex := 0;
  Solut[1] := 0; Solut[2] := 0; Solut[3] := 0;
end;

procedure TCdfFPrg.UpFinaleClick(Sender: TObject; Button: TUDBtnType);
begin
  Finale.Text := IntToStr(UpFinale.Position);
  UpE1.Max := (((StrToInt(Effectif.Text) - (UpFinale.Position*4)) DIV 4)+1)*4;
end;

procedure TCdfFPrg.UpE1Click(Sender: TObject; Button: TUDBtnType);
begin
 E1.Text := IntToStr(UpE1.Position)
end;

procedure TCdfFPrg.EffectifExit(Sender: TObject);
begin
  UpE1.Position := ((StrToInt(Effectif.Text) Div 3) div 4)*4;
  E1.Text := IntToStr( UpE1.Position);
  UpE1.Max := (((StrToInt(Effectif.Text) - (UpFinale.Position*4)) DIV 4)+1)*4;
end;

procedure TCdfFPrg.FormDeactivate(Sender: TObject);
VAR
  i_fd : Integer;
begin
  FOR i_fd := 1 TO 3 DO
    IF solut[i_fd]>0
    THEN vidage(i_fd);
end;

procedure TCdfFPrg.TrackBar1Change(Sender: TObject);
VAR
  li,lj  : Integer;
begin
  ExempNbrs.Visible := FALSE;
  ExempLabel.Visible := FAlse;
  WHILE Donnees1.Ptprecedant<>NIL DO
    Donnees1 := Donnees1.Ptprecedant;
  lj := Trackbar1.Position;
  FOR li := 1 TO lj-1 DO
    Donnees1 := Donnees1.Ptsuivant;
  T1.Text := IntToStr(Donnees1^.T1);
  T2.Text := IntToStr(Donnees1^.T2);
  T3.Text := IntToStr(Donnees1^.T3);
  T4.Text := IntToStr(((Donnees1^.T3*3)DIV 4)+ Donnees1^.E4);
  E2.Text := IntToStr(Donnees1^.E2);
  E3.Text := IntToStr(Donnees1^.E3);
  E4.Text := IntToStr(Donnees1^.E4);
  solution1.Caption :=  'Solution : '+IntToStr(lj)+'/'+IntToStr(solut[1]);
end;

procedure TCdfFPrg.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TCdfFPrg.Button3Click(Sender: TObject);
begin
  Apropos.show;
end;

procedure TCdfFPrg.TrackBar2Change(Sender: TObject);
VAR
  li,lj  : Integer;
begin
  ExempNbrs.Caption := '1';     ExempNbrs.Font.Color := clBlue;
  ExempNbrs.Visible := TRUE;
  ExempLabel.Caption := 'Exempte';  ExempLabel.Font.Color := clBlue;
  ExempLabel.Visible := True;
  WHILE Donnees2.Ptprecedant<>NIL DO
    Donnees2 := Donnees2.Ptprecedant;
  lj := Trackbar2.Position;
  FOR li := 1 TO lj-1 DO
    Donnees2 := Donnees2.Ptsuivant;
  T1.Text := IntToStr(Donnees2^.T1);  T2.Text := IntToStr(Donnees2^.T2);
  T3.Text := IntToStr(Donnees2^.T3);
  T4.Text := IntToStr(((Donnees2^.T3*3)DIV 4)+ Donnees2^.E4);
  E2.Text := IntToStr(Donnees2^.E2);  E3.Text := IntToStr(Donnees2^.E3);
  E4.Text := IntToStr(Donnees2^.E4);
  solution2.Caption :=  'Solution : '+IntToStr(lj)+'/'+IntToStr(solut[2]);
end;

procedure TCdfFPrg.TrackBar3Change(Sender: TObject);
VAR
  li,lj  : Integer;
begin
  ExempNbrs.Caption := '2';  ExempNbrs.Font.Color := clBlack;
  ExempNbrs.Visible := TRUE;
  ExempLabel.Caption := 'Exemptes';  ExempLabel.Font.Color := clBlack;
  ExempLabel.Visible := True;
  WHILE Donnees3.Ptprecedant<>NIL DO
    Donnees3 := Donnees3.Ptprecedant;
  lj := Trackbar3.Position;
  FOR li := 1 TO lj-1 DO
    Donnees3 := Donnees3.Ptsuivant;
  T1.Text := IntToStr(Donnees3^.T1);  T2.Text := IntToStr(Donnees3^.T2);
  T3.Text := IntToStr(Donnees3^.T3);
  T4.Text := IntToStr(((Donnees3^.T3*3)DIV 4)+ Donnees3^.E4);
  E2.Text := IntToStr(Donnees3^.E2);  E3.Text := IntToStr(Donnees3^.E3);
  E4.Text := IntToStr(Donnees3^.E4);
  solution3.Caption :=  'Solution : '+IntToStr(lj)+'/'+IntToStr(solut[3]);
end;


end.
