unit aprop;                  // 108

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TApropos = class(TForm)
    nom: TLabel;
    Label1: TLabel;
    Version: TLabel;
    Label3: TLabel;
    Image2: TImage;
    Memo1: TMemo;
    Button1: TButton;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label3MouseEnter(Sender: TObject);
    procedure Label3MouseLeave(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Apropos: TApropos;
  Alignes : TStringList;

implementation

{$R *.DFM}

USES
  ShellApi;

const
   Commande: array[0..80] of Char = 'mailto:patrice@boquillion.fr?subject='#0;

procedure TApropos.Button1Click(Sender: TObject);
VAR
  memoire       : TBitmap;
  nblignes      : Integer;
  Li,ly,lj      : Integer;
begin
  Panel1.Align := alClient;Panel1.Visible := TRUE;
  NbLignes := ALignes.count;memoire := TBitmap.Create;
  memoire.Height := PaintBox1.Height;memoire.Width := PaintBox1.Width;
  WITH memoire.Canvas DO
  BEGIN
    Font.Name := 'Arial';Font.Size := 10;
    IF ((TextHeight('Q')*NbLignes)>PaintBox1.Height)
    THEN lj := TextHeight('Q')*NbLignes
    ELSE lj := PaintBox1.Height;
    FOR ly := 1 TO lj DO
    BEGIN
      Font.Color := clBlue ;
      FOR li := 1 TO NbLignes DO
        TextOut(1,PaintBox1.Height-ly+(TextHeight('Q')*(Li-1)),
                ALignes.Strings[Li-1]);
      PaintBox1.Canvas.Draw(0,0,memoire);
      Sleep(55);Application.ProcessMessages;
      Font.Color :=clWhite ;
      IF ly<lj
      THEN FOR li := 1 TO NbLignes DO
          TextOut(1,PaintBox1.Height-ly+(TextHeight('Q')*(Li-1)),
                  ALignes.Strings[Li-1]);
      PaintBox1.Canvas.Draw(0,0,memoire);
    END;
  END;
  Sleep(2000); Panel1.Visible := FALSE; memoire.Free;
end;

procedure TApropos.Label3Click(Sender: TObject);
VAR
  lpc : PChar;
  ls  : String;
  li  : Integer;
begin
  lpc := @Commande;
  ls := Copy(Apropos.Caption,1,38);
  FOR li := 1 TO Length(ls) DO
    lpc[36+li] := Copy(ls,li,1)[1];
  lpc[37+length(ls)] := #0;
  IF 42<> ShellExecute(Application.Handle,'Open',lpc,
                       Nil,Nil,SW_SHOW)
  THEN MessageDlg('Le courier lectronique par dfaut'+#13+#13+
                 'n''est pas install correctement',
                 mtWarning, [mbYes], 0)
end;

procedure TApropos.Label3MouseEnter(Sender: TObject);
begin
  Apropos.Cursor := crHandPoint;
end;

procedure TApropos.Label3MouseLeave(Sender: TObject);
begin
  Apropos.Cursor := crDefault;
end;

procedure TApropos.FormCreate(Sender: TObject);
begin
  Alignes := TStringList.Create;
  Alignes.Add('Version 1.02 : 2002');
  Alignes.Add('Permet de trouver les solutions possibles pour les');
  Alignes.Add('     de l''arbitre, Rapports et feuille d''appel');
  Alignes.Add('     tours sous rserve d''une pr-inscription');
  Alignes.Add('');
  Alignes.Add('Version 2.03 : 2003');
  Alignes.Add('Modification du nombre maximal de la phase finale');
  Alignes.Add('     pouvant aller jusqu'' 16 quadrettes ce qui ');
  Alignes.Add('     permet d''avoir 8 qualifis en Zone');
  Alignes.Add('Calcul des tours avec 1 ou 2 exemptes et modifi-');
  Alignes.Add('     cation de l''algorithme ');
  Alignes.Add('');
  Alignes.Add('Version 2.04 : 2004');
  Alignes.Add('Correction d''un Bugg avec le tour 8  repchage');
  Alignes.Add('');
  Alignes.Add('Version 3.06 & 3.12 : 2012 ');
  Alignes.Add('Amlioration de l''algorithme');
  Alignes.Add('');      Alignes.Add('');        Alignes.Add('');
  Alignes.Add('');      Alignes.Add('');        Alignes.Add('');
end;

procedure TApropos.FormDestroy(Sender: TObject);
begin
  Alignes.Free;
end;

end.
